 Program File_Paint;
 
 
  //       File Paint v 1.1!
  //             !
  //                PascalABC   VCL.
  //    
  //     ,
  //      8 , 256 ,
  //        .
  //    
  //     -, 
  //   
  //    
  //     .
  //          - , 
  //            ,
  //          ,     ,
  //           ! !



uses vcl, pointrect;

//$VCLDESIGN+
var
  Form1: Form;
  TextLabel1: TextLabel;
  TextLabel2: TextLabel;
  TextLabel3: TextLabel;
  TextLabel4: TextLabel;
  TextLabel5: TextLabel;
  TextLabel6: TextLabel;
  TextLabel7: TextLabel;
  display: PaintBox;
  mode: GroupBox;
  r_read: RadioButton;
  r_write: RadioButton;
  f_l: Edit;
  but_browse: Button;
  but_ok: Button;
  s_off: SpinEdit;
  s_rez: SpinEdit;
  s_xx: SpinEdit;
  s_yy: SpinEdit;
  s_ww: SpinEdit;
  s_hh: SpinEdit;
  but_get: Button;
  but_save: Button;
  but_load: Button;
  but_try: Button;
  but_right: Button;
  but_left: Button;
  open_file: OpenDialog;
  save_file: SaveDialog;
//$VCLDESIGN-


var
xx,yy,ww,hh,off,rez,hea,size,pxst,pxfin,i,n,m,z :integer;
cl,lf :integer  ;
byt: byte;
fl: file of byte;
path,gem:string;
 bitmapo: Bitmap;


     procedure analize;
     begin
     cl:=rgb(byt,byt,byt);
     end;

     procedure renalize;
     begin
     byt:=trunc((getred(cl)+getblue(cl)+getgreen(cl))/3);
     end;




procedure Form1OnCreate;
begin
   bitmapo:=bitmap.create;
   lf:=8;
   but_get.enabled:=false;
   but_load.enabled:=false;
   but_try.enabled:=false;
   but_save.enabled:=false;
   s_xx.enabled:=false;
   s_yy.enabled:=false;
   s_hh.enabled:=false;
   s_ww.enabled:=false;
   s_off.enabled:=false;
   s_rez.enabled:=false;
   but_left.enabled:=false;
   but_right.enabled:=false;
   mode.enabled:=false;
   r_read.enabled:=false;
   r_write.enabled:=false;
end;

procedure but_browseOnClick;
begin
    open_file.Title:='  :' ;
  if open_file.Execute() then f_l.text:=open_file.FileName ;
end;

procedure but_okOnClick;
begin
   path:=f_l.text;
    if not FileExists(path) then
     begin exit;end;
  Assign(fl,path);
     mode.enabled:=true;
     r_read.enabled:=true;
     r_write.enabled:=true;
end;


procedure but_getOnClick;
begin
  xx:=s_xx.value;
  yy:=s_yy.value;
  ww:=s_ww.value;
  hh:=s_hh.value;
  rez:=s_rez.value;
  off:=s_off.value;
  Reset(fl);
  size:=FileSize(fl);
  Close(fl);
  hea:=(size-off) div rez;
  if yy+hh>hea then exit;
  if xx+ww>rez then exit;
  pxst:=off+(yy*rez)+xx;
//pxfin:=off+(yy+hh)*rez+xx+ww;
  display.width:=ww;
  display.height:=hh;
  Reset(fl);
  for n:=0 to hh-1 do begin
  seek(fl,pxst+n*rez);
  for i:=0 to ww-1 do begin
  read(fl,byt);
  analize();
  display.setpixel(i,n,cl);
  end;
  end;
  Close(fl);

    if display.width > 640 then begin
   but_left.enabled:=true;
   but_right.enabled:=true;
  end else begin
   but_left.enabled:=true;
   but_right.enabled:=true;
  end;

end;

procedure but_saveOnClick;
begin
   save_file.Filter:='Bitmap|*.bmp';
 save_file.Title:='   :' ;
 if save_file.Execute() then begin
 bitmapo.width:=display.width;
 bitmapo.height:=display.height;
bitmapo.canvas.copyrect(RectF(0,0,bitmapo.width,bitmapo.height),display.canvas,RectF(0,0,bitmapo.width,bitmapo.height));
bitmapo.savetofile(save_file.FileName);
end;
end;

procedure but_loadOnClick;
begin
    open_file.Title:='     :' ;
  if open_file.Execute() then begin
  gem:=open_file.FileName ;
   bitmapo.LoadFromFile(gem);
  display.width:=bitmapo.width;
  display.height:=bitmapo.height;
   display.left:=lf;
   display.canvas.copyrect(RectF(0,0,display.width,bitmapo.height),bitmapo.canvas,RectF(0,0,display.width,display.height));

  s_ww.value:=display.width;
  s_hh.value:=display.height;

  if display.width > 640 then begin
   but_left.enabled:=true;
   but_right.enabled:=true;
  end else begin
   but_left.enabled:=true;
   but_right.enabled:=true;
  end;

   end;
end;

procedure but_tryOnClick;
begin
  xx:=s_xx.value;
  yy:=s_yy.value;
  ww:=s_ww.value;
  hh:=s_hh.value;
  rez:=s_rez.value;
  off:=s_off.value;
  pxst:=off+(yy*rez)+xx;
  Reset(fl);
  for n:=0 to hh-1 do begin
  seek(fl,pxst+n*rez);
  for i:=0 to ww-1 do begin
  cl:=display.Canvas.getpixel(i,n);
  renalize();
  write(fl,byt);
  end;
  end;
  Close(fl);
end;

procedure r_writeOnClick;
begin
  s_ww.value:=display.width;
  s_hh.value:=display.height;
   but_get.enabled:=false;
   but_load.enabled:=true;
   but_try.enabled:=true;
   but_save.enabled:=false;
   s_off.enabled:=true;
   s_rez.enabled:=true;
   s_xx.enabled:=true;
   s_yy.enabled:=true;
   s_hh.enabled:=false;
   s_ww.enabled:=false;

end;

procedure r_readOnClick;
begin
   but_get.enabled:=true;
   but_load.enabled:=false;
   but_try.enabled:=false;
   but_save.enabled:=true;
   s_off.enabled:=true;
   s_rez.enabled:=true;
   s_xx.enabled:=true;
   s_yy.enabled:=true;
   s_hh.enabled:=true;
   s_ww.enabled:=true;
end;

procedure but_rightOnClick;
begin
  display.left:=display.left-128;
  if display.left<lf then display.left:=display.left+128;
end;

procedure but_leftOnClick;
begin
  display.left:=display.left+128;
  if display.left>640 then display.left:=display.left-128;
end;

procedure InitControl;
begin
  Form1:= Form.Create(0,0,700,580);
  Form1.InitControl(True,False,alNone,crDefault,clBtnFace,'1','');
  TextLabel1:= TextLabel.Create(Form1,8,8,49,22);
  TextLabel1.InitControl(True,True,alNone,crDefault,clBtnFace,':','      .');
  TextLabel2:= TextLabel.Create(Form1,16,40,134,22);
  TextLabel2.InitControl(True,True,alNone,crDefault,clBtnFace,' :','');
  TextLabel3:= TextLabel.Create(Form1,288,40,190,22);
  TextLabel3.InitControl(True,True,alNone,crDefault,clBtnFace,' :','');
  TextLabel4:= TextLabel.Create(Form1,16,112,60,22);
  TextLabel4.InitControl(True,True,alNone,crDefault,clBtnFace,':','');
  TextLabel5:= TextLabel.Create(Form1,176,112,69,22);
  TextLabel5.InitControl(True,True,alNone,crDefault,clBtnFace,':','');
  TextLabel6:= TextLabel.Create(Form1,344,112,73,22);
  TextLabel6.InitControl(True,True,alNone,crDefault,clBtnFace,':','');
  TextLabel7:= TextLabel.Create(Form1,512,112,71,22);
  TextLabel7.InitControl(True,True,alNone,crDefault,clBtnFace,':','');
  display:= PaintBox.Create(Form1,8,200,673,345);
  display.InitControl(True,True,alNone,crDefault,0,'0','');
  mode:= GroupBox.Create(Form1,8,64,665,41);
  mode.InitControl(True,True,alNone,crDefault,clBtnFace,'','  ,     .');
  r_read:= RadioButton.Create(mode,216,16,105,20);
  r_read.InitControl(True,True,alNone,crDefault,clBtnFace,'','    .');
  r_write:= RadioButton.Create(mode,480,16,97,17);
  r_write.InitControl(True,True,alNone,crDefault,clBtnFace,'','    .');
  f_l:= Edit.Create(Form1,64,8,425,26);
  f_l.InitControl(True,True,alNone,crDefault,clWindow,'','     ,    .');
  but_browse:= Button.Create(Form1,496,8,75,25);
  but_browse.InitControl(True,True,alNone,crDefault,0,'...',',   .');
  but_ok:= Button.Create(Form1,584,8,97,57);
  but_ok.InitControl(True,True,alNone,crDefault,0,'','  ,   .');
  s_off:= SpinEdit.Create(Form1,160,40,113,28);
  s_off.InitControl(True,True,alNone,crDefault,clWindow,'0','     .');
  s_rez:= SpinEdit.Create(Form1,488,40,81,28);
  s_rez.InitControl(True,True,alNone,crDefault,clWindow,'1024','    .');
  s_xx:= SpinEdit.Create(Form1,80,112,73,28);
  s_xx.InitControl(True,True,alNone,crDefault,clWindow,'0',' -     .');
  s_yy:= SpinEdit.Create(Form1,248,112,73,28);
  s_yy.InitControl(True,True,alNone,crDefault,clWindow,'256','Y -     .');
  s_ww:= SpinEdit.Create(Form1,424,112,73,28);
  s_ww.InitControl(True,True,alNone,crDefault,clWindow,'128','   .');
  s_hh:= SpinEdit.Create(Form1,592,112,73,28);
  s_hh.InitControl(True,True,alNone,crDefault,clWindow,'48','   .');
  but_get:= Button.Create(Form1,8,152,121,33);
  but_get.InitControl(True,True,alNone,crDefault,0,'','    .');
  but_save:= Button.Create(Form1,184,152,121,33);
  but_save.InitControl(True,True,alNone,crDefault,0,'','    .');
  but_load:= Button.Create(Form1,384,152,121,33);
  but_load.InitControl(True,True,alNone,crDefault,0,'','      .');
  but_try:= Button.Create(Form1,560,152,121,33);
  but_try.InitControl(True,True,alNone,crDefault,0,'','      !');
  but_right:= Button.Create(Form1,344,152,41,33);
  but_right.InitControl(True,False,alNone,crDefault,0,'>','');
  but_left:= Button.Create(Form1,304,152,41,33);
  but_left.InitControl(True,False,alNone,crDefault,0,'<','');
  open_file:= OpenDialog.Create;
  save_file:= SaveDialog.Create;
  TextLabel1.Font.Name:= 'Arial';
  TextLabel1.Font.Size:= 14;
  TextLabel2.Font.Name:= 'Arial';
  TextLabel2.Font.Size:= 14;
  TextLabel3.Font.Name:= 'Arial';
  TextLabel3.Font.Size:= 14;
  TextLabel4.Font.Name:= 'Arial';
  TextLabel4.Font.Size:= 14;
  TextLabel5.Font.Name:= 'Arial';
  TextLabel5.Font.Size:= 14;
  TextLabel6.Font.Name:= 'Arial';
  TextLabel6.Font.Size:= 14;
  TextLabel7.Font.Name:= 'Arial';
  TextLabel7.Font.Size:= 14;
  mode.Font.Name:= 'Arial';
  mode.Font.Size:= 14;
  r_read.Font.Name:= 'Arial';
  r_read.Font.Size:= 14;
  r_write.Font.Name:= 'Arial';
  r_write.Font.Size:= 14;
  f_l.Font.Name:= 'Arial';
  f_l.Font.Size:= 12;
  but_browse.Font.Name:= 'Arial';
  but_browse.Font.Size:= 11;
  but_ok.Font.Name:= 'Arial';
  but_ok.Font.Size:= 16;
  s_off.Font.Name:= 'Arial';
  s_off.Font.Size:= 12;
  s_rez.Max:= 2048;
  s_rez.Font.Name:= 'Arial';
  s_rez.Font.Size:= 12;
  s_xx.Min:= -2048;
  s_xx.Max:= 2048;
  s_xx.Font.Name:= 'Arial';
  s_xx.Font.Size:= 12;
  s_yy.Max:= 2048;
  s_yy.Font.Name:= 'Arial';
  s_yy.Font.Size:= 12;
  s_ww.Max:= 2048;
  s_ww.Font.Name:= 'Arial';
  s_ww.Font.Size:= 12;
  s_hh.Max:= 2048;
  s_hh.Font.Name:= 'Arial';
  s_hh.Font.Size:= 12;
  but_get.Font.Name:= 'Arial';
  but_get.Font.Size:= 16;
  but_save.Font.Name:= 'Arial';
  but_save.Font.Size:= 16;
  but_load.Font.Name:= 'Arial';
  but_load.Font.Size:= 16;
  but_try.Font.Name:= 'Arial';
  but_try.Font.Size:= 16;
  but_right.Font.Name:= 'Arial';
  but_right.Font.Size:= 22;
  but_left.Font.Name:= 'Arial';
  but_left.Font.Size:= 22;
  Form1.OnCreate:=Form1OnCreate;
  r_read.OnClick:=r_readOnClick;
  r_write.OnClick:=r_writeOnClick;
  but_browse.OnClick:=but_browseOnClick;
  but_ok.OnClick:=but_okOnClick;
  but_get.OnClick:=but_getOnClick;
  but_save.OnClick:=but_saveOnClick;
  but_load.OnClick:=but_loadOnClick;
  but_try.OnClick:=but_tryOnClick;
  but_right.OnClick:=but_rightOnClick;
  but_left.OnClick:=but_leftOnClick;
  Form1.Position:= poScreenCenter;
  Form1.OnCreate;
  Form1.Show;
end;

begin
  InitControl;

end.


























































